﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

namespace howto_float_double_speed
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Compare performances.
        private void btnGo_Click(object sender, EventArgs e)
        {
            txtTimeFloat.Clear();
            txtTimeDouble.Clear();
            txtTimeDecimal.Clear();
            Cursor = Cursors.WaitCursor;
            Refresh();

            int num_trials = int.Parse(txtNumTrials.Text);
            Stopwatch watch = new Stopwatch();
            float float1, float2, float3;
            double double1, double2, double3;
            decimal decimal1, decimal2, decimal3;

            watch.Start();
            for (int i = 0; i < num_trials; i++)
            {
                float1 = 1.23f;
                float2 = 4.56f;
                float3 = float1 / float2;
            }
            watch.Stop();
            txtTimeFloat.Text =
                watch.Elapsed.TotalSeconds.ToString() + " sec";
            txtTimeFloat.Refresh();

            watch.Reset();
            watch.Start();
            for (int i = 0; i < num_trials; i++)
            {
                double1 = 1.23d;
                double2 = 4.56d;
                double3 = double1 / double2;
            }
            watch.Stop();
            txtTimeDouble.Text =
                watch.Elapsed.TotalSeconds.ToString() + " sec";
            txtTimeDouble.Refresh();

            // Scale by a factor of 10 for decimal.
            num_trials /= 10;
            watch.Reset();
            watch.Start();
            for (int i = 0; i < num_trials; i++)
            {
                decimal1 = 1.23m;
                decimal2 = 4.56m;
                decimal3 = decimal1 / decimal2;
            }
            watch.Stop();
            txtTimeDecimal.Text = "~" +
                (watch.Elapsed.TotalSeconds * 10).ToString() + " sec";

            Cursor = Cursors.Default;
        }
    }
}
